package net.grandnature.android.soundball.sound;


/**
 * 音の波形を生成、管理するクラス。
 */
public class Note {
	private static double region = 0.5; // 振幅の幅 -0.5 から 0.5
	private byte[] soundData;
	private int sampleRate;
	public Note(int sampleRate) {
		this.sampleRate = sampleRate;
		this.soundData = createSoundData();
	}
	public byte[] getSoundData() {
		return soundData;
	}
	public int getSampleRate() {
		return sampleRate;
	}
	private byte[] createSoundData() {
		return createSineWave();
	}
	// 正弦波を生成する
	private byte[] createSineWave() {
		byte[] b = new byte[sampleRate];
		for (int i = 0; i < sampleRate; i++) {
			double d = region * Math.sin(2.0 * Math.PI * 220.0f * i /sampleRate);
			b[i] = (byte)(d * 127.0);
		}
		return b;
	}
}
