package net.grandnature.android.soundball.sound;

import android.media.AudioFormat;
import android.media.AudioManager;
import android.media.AudioTrack;

public class SoundballPlayer {
	private AudioTrack at;

	public void release() {
		try {
			if(at.getState() == AudioTrack.PLAYSTATE_PLAYING)
				at.stop();
			at.release();
		} catch (RuntimeException e) {
			e.printStackTrace();
		} finally {
			at = null;
		}
	}

	public void play(Note note) {
		if(at!=null) 
			at.reloadStaticData();
		else 
			createAudioTrack(note);
		at.play();
	}

	public void stop() {
		if(at!=null && at.getPlayState() == AudioTrack.PLAYSTATE_PLAYING) 
			at.pause();
	}

	public void setVolume(float left, float right) {
		if(at.getPlayState() == AudioTrack.PLAYSTATE_PLAYING) {
			at.setStereoVolume(left, right);
		}
	}

	private void createAudioTrack(Note note) {
		byte[] dat = note.getSoundData();
		int datLen = dat.length;
	
        at = new AudioTrack(
        		AudioManager.STREAM_MUSIC, note.getSampleRate(), AudioFormat.CHANNEL_CONFIGURATION_MONO, 
        		AudioFormat.ENCODING_PCM_8BIT, datLen, AudioTrack.MODE_STATIC);
        at.setLoopPoints(0, datLen, -1);
		int ret = at.write(dat, 0, dat.length);
		if(ret == AudioTrack.ERROR_INVALID_OPERATION){
	
			}else if(ret == AudioTrack.ERROR_BAD_VALUE){
	
		}
	}
}
